#include <QDebug>
#include <QMetaObject>
#include <QMetaProperty>

#include "person.h"

void showObject(QObject* object)
{
	const QMetaObject *metaObject = object->metaObject();
	int count = metaObject->propertyCount();
	for (int i = 0; i < count; i++)
	{
		QMetaProperty metaProperty = metaObject->property(i);
		const char *name = metaProperty.name();
		const char *typeName = metaProperty.typeName();
		//qDebug() << "typeName=" << typeName << " / name=" << name << " / " << object->property(name);
		qDebug() << typeName <<  name << object->property(name);
	}
}

Person::Person(QObject *parent) : Base(parent)
{
	m_name = "";
	m_age = 0;
}

QDataStream& operator << (QDataStream &ds, const Base& obj)
{
	const QMetaObject *metaObject = obj.metaObject();
	for(int i = 0; i < metaObject->propertyCount(); ++i)
	{
		QMetaProperty metaProperty= metaObject->property(i);
		if(metaProperty.isStored(&obj))
		{
			ds << metaProperty.read(&obj);
		}
	}
	return ds;
}

QDataStream& operator >> (QDataStream &ds, Base& obj)
{
	QVariant var;
	const QMetaObject *metaObject = obj.metaObject();
	for(int i = 0; i < metaObject->propertyCount(); ++i)
	{
		QMetaProperty metaProperty= metaObject->property(i);
		if(metaProperty.isStored(&obj)) {
			ds >> var;
			metaProperty.write(&obj, var);
		}
	}
	return ds;
}
