#ifndef PERSON_H
#define PERSON_H

#include <QDataStream>
#include <QObject>

class Base : public QObject
{
public:
	explicit Base(QObject *parent = 0) : QObject(parent) {}
	virtual ~Base() {}
};

class Person : public Base
{
	Q_OBJECT
	Q_PROPERTY(QString name READ name WRITE setName)
	Q_PROPERTY(int age READ age WRITE setAge)
public:
	explicit Person(QObject *parent = 0);
	virtual ~Person() {}

	QString name()
	{
		return m_name;
	}

	void setName(QString name)
	{
		m_name = name;
	}

	int age()
	{
		return m_age;
	}

	void setAge(int age)
	{
		m_age = age;
	}

private:
	QString m_name;
	int m_age;

signals:

public slots:

};

void showObject(QObject* object);
QDataStream& operator << (QDataStream& ds, const Base& obj);
QDataStream& operator >> (QDataStream& ds, Base& obj);

#endif // PERSON_H
